<?php
/**
 * @version:	1.1
 * @package		embedanonform (plugin)
 * @author:		Erik Schütten - anonform.com
 * @copyright	Copyright (c) 2024 Anonform Ab
 * @license:	GNU/GPL license: https://www.gnu.org/copyleft/gpl.html
 */

defined( '_JEXEC' ) || die;

use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Factory;

class PlgContentEmbedAnonform extends CMSPlugin {

	public function onContentPrepare($context, &$article, &$params, $page = 0) {

		$doc = Factory::getApplication()->getDocument();
		$wa  = $doc->getWebAssetManager();
		$pluginPath = 'plugins/content/' . $this->_name;

		$wa->registerAndUseStyle('embedanonform.mainstyle', $pluginPath.'/css/embed-anonform.css');

		preg_match_all("/{anonform link=\'(.*?)\'}/s", $article->text, $matches, PREG_SET_ORDER);

		foreach($matches as $match) {

			if (!empty($match[0]) && !empty($match[1])) {

				$output = <<<EOT
<iframe id="anonform-app" src="{$match[1]}"></iframe>
<script>!function(){var e=document.getElementById("anonform-app");var n=window.addEventListener?"addEventListener":"attachEvent";(0,window[n])("attachEvent"==n?"onmessage":"message",function(n){var t,a=n[n.message?"message":"data"];t=a,e.style.height=t+"px"},!1),window.onresize=function(){e.contentWindow.postMessage("parentWindowResized","*")}}();</script>
EOT;
				$article->text = str_replace($match[0], $output, $article->text);

			}
		}

	}

}
